#ifndef  _IMU_DRIVER_H_
#define  _IMU_DRIVER_H_
#ifdef __cplusplus
extern "C" {
#endif
#include "main.h"
#include "string.h"
#include "stdio.h"


#define SPI_REG_TEMP_HIGH_WINDOW0               0x0E
#define SPI_REG_TEMP_LOW_WINDOW0                0x10
#define SPI_REG_XGYRO_HIGH_WINDOW0              0x12
#define SPI_REG_XGYRO_LOW_WINDOW0               0x14
#define SPI_REG_YGYRO_HIGH_WINDOW0              0x16
#define SPI_REG_YGYRO_LOW_WINDOW0               0x18
#define SPI_REG_ZGYRO_HIGH_WINDOW0              0x1A
#define SPI_REG_ZGYRO_LOW_WINDOW0               0x1C
#define SPI_REG_XACCL_HIGH_WINDOW0              0x1E
#define SPI_REG_XACCL_LOW_WINDOW0               0x20
#define SPI_REG_YACCL_HIGH_WINDOW0              0x22
#define SPI_REG_YACCL_LOW_WINDOW0               0x24
#define SPI_REG_ZACCL_HIGH_WINDOW0              0x26
#define SPI_REG_ZACCL_LOW_WINDOW0               0x28

void SPI_Master_Init(void);
void SPI_Master_Read_Burst(void);
void SPI_Master_Read_Regs(void);
void I2C_Master_Init(void);
void I2C_Master_Read(void);
void CAN_User_Init(CAN_HandleTypeDef* hcan);

uint32_t crc_crc32(uint32_t crc, const uint8_t *buf, uint32_t size);

#ifdef __cplusplus
}
#endif


#endif
